local lyric_time = {};
local lyric_text = {};

local lyric_frame_x;
local lyric_frame_y;
local lyric_frame_width;
local lyric_frame_height;
local lyric_shadow_blur;
local lyric_shadow_alpha;
local lyric_text_size;
local lyric_text_color;
local lyric_color_alpha;
local lyric_color_red;
local lyric_color_green;
local lyric_color_blue;
local lyric_frame_count;
local lyric_frame_start;
local lyric_frame_offset;

local temp_text;
local image;

function get_sorted_index(k, arr)

    for i = 1, #arr do
        if tonumber(k) <= arr[i] then
            return i;
        end
    end

    return #arr + 1
end


function setup()

    local layer_datas = viva_layer.get_data(viva_layer.this_layer())
    image = 0

    for k, v in pairs(layer_datas) do
        if k == "lyric_frame_x" then
            lyric_frame_x = v;
        elseif k == "lyric_frame_y" then
            lyric_frame_y = v;
        elseif k == "lyric_frame_width" then
            lyric_frame_width = v;
        elseif k == "lyric_frame_height" then
            lyric_frame_height = v;
        --颜色通道
        elseif k == "lyric_color_alpha" then
            lyric_color_alpha = v;
        elseif k == "lyric_color_red" then
            lyric_color_red = v;
        elseif k == "lyric_color_green" then
            lyric_color_green = v;
        elseif k == "lyric_color_blue" then
            lyric_color_blue = v;
        elseif k == "lyric_shadow_blur" then
            lyric_shadow_blur = v;
            -- print("lyric_shadow_blur---->" .. lyric_shadow_blur)
        elseif k == "lyric_shadow_alpha" then
            lyric_shadow_alpha = v;
            -- print("lyric_shadow_alpha---->" .. lyric_shadow_alpha)
        elseif k == "lyric_frame_count" then
            lyric_frame_count = v;
            print("lyric_frame_count---->" .. lyric_frame_count)
        elseif k == "lyric_frame_start" then
            lyric_frame_start = v;
            print("lyric_frame_start---->" .. lyric_frame_start)
        elseif k == "lyric_frame_offset" then
            lyric_frame_offset = v;
            print("lyric_frame_offset---->" .. lyric_frame_offset)
        else
            local idx = get_sorted_index(k, lyric_time)
            table.insert(lyric_time, idx, tonumber(k))
            table.insert(lyric_text, idx, v)
        end
    end

    -- print("lyric_frame_count: " .. lyric_frame_count)
end

-- 从帧索引获取当前歌词文字
function get_lyric_index(frame_index)

    local forward_text
    local current_text

    for index = 1, #lyric_time do
        if lyric_time[index] < (frame_index % lyric_frame_offset) + lyric_frame_start then
            forward_text = lyric_text[index];
        elseif frame_index == (lyric_time[index] + lyric_frame_start) then
            current_text = lyric_text[index];
            break;
        else
            current_text = forward_text
            break;
        end
    end

    return current_text;
end

function draw()

    local index = viva.frame_index()

    local show_text = get_lyric_index(index)

    if show_text ~= nil then
        h2d.begin_frame_simple()
        h2d.fill_color(h2d_color.rgba_f(lyric_color_red, lyric_color_green,
                                        lyric_color_blue, lyric_color_alpha))
        h2d.font_face("font")
        h2d.text_align(H2D_ALIGN.H2D_ALIGN_CENTER)
        h2d.text_drop_shadow(lyric_shadow_blur, -1, 1, h2d_color.rgba_f(0, 0, 0, lyric_shadow_alpha))

        if temp_text ~= show_text then
            lyric_text_size = h2d.text_box_formatter(lyric_frame_x, lyric_frame_y,
                lyric_frame_width, lyric_frame_height, show_text)
            if image ~= 0 then
                h2d.delete_image(image)
            end
            h2d.font_size(lyric_text_size)
            image = h2d.text_box_image(lyric_frame_x, lyric_frame_y,
                lyric_frame_width, lyric_frame_height, show_text)
        end

        h2d.draw_text_box_image(lyric_frame_x, lyric_frame_y, lyric_frame_width, lyric_frame_height, image)
        h2d.end_frame()

        temp_text = show_text
    else
        h2d.begin_frame_simple()

        h2d.begin_path();

        h2d.fill_color(h2d_color.rgba_f(0, 0, 0, 0));

        h2d.circle(0, 0, 1);

        h2d.fill();

        h2d.end_frame()
    end
end


function clenup()

    if image ~= 0 then
        h2d.delete_image(image)
    end
    lyric_time = nil
    lyric_text = nil
end
